#include "clique.h"

int findNode_LargestDegree(set<int> subG, bool* adjMat, unsigned int num_nodes){
    int num = 0;
    int count;
    int c = -1;

    int tempC;
    int temp;

    set<int>::iterator it;
    set<int>::iterator it2;

    for(it = subG.begin(); it != subG.end(); ++it){
        tempC = (*it);

        count = 0;

        for(it2 = subG.begin(); it2 != subG.end(); ++it2){
            temp = (*it2);

            if(tempC != temp){
                if(adjMat[tempC * num_nodes + temp]){
                    count++;
                }
            }
        }

        if(c == -1){
            num = count;
            c = tempC;
        }else{
            if(num < count){
                c = tempC;

                num = count;
            }
        }

    }

    return c;
}

int candidateNodeDetection(set<int> subG, queue<int> *candicatesInCurrLevel,
                            bool* adjMat, unsigned int num_nodes){
    int q = findNode_LargestDegree(subG, adjMat, num_nodes);

    if(q != -1){
        (*candicatesInCurrLevel).push(q);

        set<int>::iterator it;
        int temp;

        for(it = subG.begin(); it != subG.end(); ++it){
            temp = (*it);

            if(adjMat[q * num_nodes + temp] == false && q != temp){
                (*candicatesInCurrLevel).push(temp);
            }
        }
    }

    return q;
}

void expand(set<int> subG, set<int> cand, vector<int> *his,
                      bool isFirstLevel, set<int> firstLevelNodes,
                      vector<vector<int> > *cliques, int* expandNum,
                      bool* adjMat, unsigned int num_nodes){
    set<int>::iterator it;
    int temp;

    if((*expandNum) < 1){
        queue<int> candicatesInCurrLevel;

        int q = candidateNodeDetection(subG, &candicatesInCurrLevel, adjMat, num_nodes);

        if(candicatesInCurrLevel.size() != 0){
            vector<int> his1;
            for(int i = 0; i < (*his).size(); ++i){
                his1.push_back((*his)[i]);
            }

            /////////////// Start
            while((*expandNum) < 1){

                q = candicatesInCurrLevel.front();
                candicatesInCurrLevel.pop();

                if(firstLevelNodes.size() == 0 ||
                        (firstLevelNodes.size() != 0 && firstLevelNodes.find(q) == firstLevelNodes.end())){
                    his1.push_back(q);

                    if(isFirstLevel){
                        firstLevelNodes.insert(q);
                    }

                    //	get new subgraph
                    set<int> subG1;
                    set<int> cand1;

                    for(it = subG.begin(); it != subG.end(); ++it){
                        temp = (*it);

                        if(adjMat[q * num_nodes + temp] && temp != q){
                            subG1.insert(temp);
                        }
                    }

                    //	get new candidates
                    for(it = cand.begin(); it != cand.end(); ++it){
                        temp = (*it);

                        if(adjMat[q * num_nodes + temp] && temp != q){
                            cand1.insert(temp);
                        }
                    }

                    if(subG1.size() == 0){
                        if(his1.size() >= 3){
                            vector<int> oneclique;

                            for(int k = 0; k < his1.size(); ++k){
                                oneclique.push_back(his1[k]);
                            }

                            (*cliques).push_back(oneclique);

                            (*expandNum)++;

                            break;
                        }
                    }else if(subG1.size() == 1){
                        if(his1.size() >= 2){
                            vector<int> oneclique;

                            for(int k = 0; k < his1.size(); ++k){
                                oneclique.push_back(his1[k]);
                            }

                            oneclique.push_back(*(subG1.begin()));

                            (*cliques).push_back(oneclique);

                            (*expandNum)++;

                            break;
                        }
                    }else{
                        expand(subG1, cand1, &his1, false, firstLevelNodes,
                               cliques, expandNum, adjMat, num_nodes);
                    }

                    his1.pop_back();
                }
            }
        }
    }
}

void cliqueSimp(bool* adjMat, unsigned int num_nodes, vector<vector<int> > *cliques){
    set<int> subG;

    set<int> cand;

    for(int i = 0; i < num_nodes; ++i){
        subG.insert(i);
        cand.insert(i);
    }

    ////////////////////////////
    // expanding history
    vector<int> his;
    set<int> firstLevelNodes;

    int expandNum = 0;
    //	First level, true
    expand(subG, cand, &his, true, firstLevelNodes, cliques, &expandNum, adjMat, num_nodes);

    subG.clear();
    cand.clear();

    his.clear();
    firstLevelNodes.clear();
}

void readGraph(char* fn, bool* adjMat, unsigned int num_nodes2){
    FILE* pFile = fopen(fn, "rb");

    if(pFile != NULL){
        fread(adjMat, sizeof(bool), num_nodes2, pFile);

        fclose(pFile);
    }else{
        printf("Cannot open file %s\n", fn);
    }
}

void storeConnectors(char* fn, vector<vector<int> > cliques){
    FILE* pFile = fopen(fn, "wt");

    if(pFile != NULL){
        unsigned int i, j;

        for(i = 0; i < cliques.size(); ++i){
            for(j = 0; j < cliques[i].size(); ++j){
                fprintf(pFile, "%d ", cliques[i][j]);
            }

            fprintf(pFile, "\n");
        }

        fclose(pFile);
    }else{
        printf("Cannot open file %s\n", fn);
    }
}

int main(int argc, char* argv[]){
    char ifn[1024];
    char ofn[1024];

    unsigned int num_nodes, num_nodes2;

    if (argc != 4) {
        // Tell the user how to run the program
        printf("Input Error. Please input: the input and output data path, number of nodes, number of iterations and C2.");

        return 1;
    }else{
        for (unsigned int i = 1; i < 4; ++i) {
            // Remember argv[0] is the path to the program, we want from argv[1] onwards
           if(i == 1){
               strcpy(ifn, argv[i]);
           }else if(i == 2){
               strcpy(ofn, argv[i]);
           }else if(i == 3){
               num_nodes = atoi(argv[i]);
           }
       }
    }

    num_nodes2 = num_nodes * num_nodes;

    bool* adjMat = new bool[num_nodes2];
    memset(adjMat, false, sizeof(bool) * num_nodes2);

    readGraph(ifn, adjMat, num_nodes2);

    vector<vector<int> > cliques;

    cliqueSimp(adjMat, num_nodes, &cliques);

    storeConnectors(ofn, cliques);

    delete[] adjMat;

    return 1;
}
